clear all
close all
% THE APLIED INPUT FILES ARE GENERATED WITH A HYDRODYNAMIC MODEL ON THE
% DIAMOD using SOBEK
%import hydrodynamic model results (time, wterlevel) for  [C,k]
Cdk=readmatrix('v2_k15_C2.csv');
%import hydrodynamic model results (time, wterlevel) for  [C,k-dk]
Ck=readmatrix('v2_k10_C2');
%import hydrodynamic model results (time, wterlevel) for  [C-dC,k]
dCk=readmatrix('v2_k10_C1');
ntijd=size(Ck,1);
dp(1)=5;
dp(2)=1;
% construct Jacobean index 1: parameter (1=C, 2=k) , index 2: time, index
% 3: nodenr (1-6)
for j=2:ntijd
    for kk=1:6
        J(1,j-1,kk)=(Cdk(j,kk+1)-Ck(j,kk+1))/dp(1);
        J(2,j-1,kk)=(Ck(j,kk+1)-dCk(j,kk+1))/dp(2);
    end
end
% produce plots
h=figure;
for kk=1:1:6
    subplot(3,2,kk);
    plot(J(1,1:end,kk),'-.k');
    hold on
    plot(J(2,1:end,kk),'-k');
    xlabel('Time [min]');
    ylabel('\Delta h/\Delta k_n , \Delta h/\Delta C');
    ylim([-0.05,0.05]);
    grid on
    title(['Elements of the Jacobian matrix for node nr.: ',num2str(kk)]);
    legend('\Delta h/\Delta k_n', '\Delta h/\Delta C');
    set(findall(gcf,'-property','FontSize'),'FontSize',18)
    set(findall(gcf,'-property','Font'),'Font','Arial')
end
% enlarge part for node 2
h=figure;
n=size(J,2);
plot(J(1,1:n,2),'-.k');
hold on
plot(J(2,1:n,2),'-k');
grid on
xlim([0,160]);
ylim([-0.03,0.01]);
    title(['Elements of the Jacobian matrix for node nr.: ',num2str(2)]);
    legend('\Delta h/\Delta k_n', '\Delta h/\Delta C');
    set(findall(gcf,'-property','FontSize'),'FontSize',18)
    set(findall(gcf,'-property','Font'),'Font','Arial')


h=figure;
for i=1:1:1401
Q(i)=0.125-0.125*cos((i-1)/700*2*pi);
end
plot(Q);
grid on
xlabel('Time [min]');
ylabel('Discharge [m^3/s]');
title('Boundary condotion at node 1');


    