clear all
close all
% input
% set standard deviation for the measuring uncertaintyy
% read Hydrograph data (equidistant time series is expected her)
load('loc1loc2.mat');
n=size(y,1);
%make sure an even number of datapoint is used
if mod(n,2)==1
    n=n-1;
end
% time between samples is 1 minute
dt=1;
%
% user input
%
% ask user input for value for gamma
vraag=['Value for gamma: '];
gamma=input(vraag);
%ask value for process noise (1 std)
vraag=['process noise (white) (1*std) in [m]: '];
meas_uncert1=input(vraag);
meas_uncert2=meas_uncert1; % same noise for bot hydrographs
%define time vector
t=(0:n-1)*dt;
% add artifical measuring noise to the data y->y1 
for i=1:1:size(y,1)
    y1(i)=y(i)+random('Normal',0,meas_uncert1);
end
y1=y1';
% time domain analysis for esatblishing lower limit sampling frequency
% determining the autocorrelation function
u=autocorr(y);
uu=autocorr(yy);
% define lag vector
for i=1:1:size(u,1)
    lag_time(i)=i-1;
end
% plot the autocorrelation functions obtained
h=figure;
plot(lag_time,u,'-k','LineWidth',2);
hold on
plot(lag_time,uu,'-.k','LineWidth',2);
legend('Loc 1','Loc 2');
grid on
xlabel('Time lag [min]','FontSize',14);
ylabel('Autocorrelation function [-]','FontSize',14);
title('Autocorrelation function hydrograph loc 1 and loc 2','FontSize',14);
grid on
%
%determine the standarddeviation for the signals y and yy
%
sigma_process1=std(y);
sigma_process2=std(yy);
%
% set value for sigma monitoring
%ask value for process noise (1 std)
vraag=['monitoring uncertainty (1*std) in [m]: '];
sigma_monitoring =input(vraag);
%
crit1=2*gamma*(sigma_monitoring/sigma_process1)^2;
crit2=2*gamma*(sigma_monitoring/sigma_process2)^2;
c_1=0.5*sigma_process1^2*(3+u(3)-4*(u(2)));
c_2=0.5*sigma_process1^2*(3+uu(3)-4*(uu(2)));
%
% plot the hydrographs
%
h=figure;
plot(y,'-ko','LineWidth',2);
hold on
plot(yy,'-r+','LineWidth',2);
xlabel('Time [minutes]','FontSize',14);
ylabel('Waterlevel [m]','FontSize',14);
grid on
title([' Example 1 hydrographs 1 and 2, \sigma_p_1= ',num2str(sigma_process1),' [m]',...
     ' \sigma_p_2= ',num2str(sigma_process2),' [m]'],'FontSize',14);
legend('Loc 1','Loc 2')
% Sampling frequency in the inported signal (once per minute) convert to
% hourly rate Fs
Fs=60/dt;
% frequency domain analysis using the matlab Fast Fourier Transform function fft
Y=fft(y);
YU=fft(yy);
%set frequency vector
f=2*Fs*(0:(n/2))/n;
% set the complex magnitude for each frequency
Pyy=abs(Y/n);
Pyyu=abs(YU/n);
%reduce the length of the magnitude vector to single sided spectrum
P=Pyy(1:n/2+1);
PU=Pyyu(1:n/2+1);
%correct result for 2 side spectrum to one sided spectrum
P(2:end-1)=2*P(2:end-1);
PU(2:end-1)=2*PU(2:end-1);
% plot spectra
h=figure;
plot(f,log10(abs(P)),'-k','LineWidth',2);
hold on
plot(f,log10(abs(PU)),'-.k','LineWidth',2);
hold on
min_1=min(P);
min_2=min(PU);
plot([0,f(n/2)],[log10(min_1),log10(min_1)],'-b','LineWidth',2);
hold on
plot([0,f(n/2)],[log10(min_2),log10(min_2)],'-.b','LineWidth',2);
hold on
xlabel('Frequency [h^-^1]');
legend('Spectrum Loc 1','Spectrum Loc 2','Min uncert. Loc 1','Min uncert. Loc 2');
ylabel('log^1^0|P(f)|','FontSize',14);
title('Full spectrum','FontSize',14);
grid on
imax=0;
for i=1:1:size(Y,1)
    t(i)=i-1;
    if log10(abs(Y(i)/n))<log10(gamma*meas_uncert1)
        Y(i)=0;
        if imax==0
            imax=i;
        end
    end
end
% reconstruct signal from reduced spectrum, plot both along with the residue
zz=ifft(Y);
h=figure;
plot(t,y,'-k+','LineWidth',2);
hold on
plot(t,y1,'-ko','LineWidth',2);
hold on
if imax==0
    step=1;
else
    step=round(n/(2*imax));
end
plot(t(1:step:end),zz(1:step:end),'-go');
hold on
plot(y1-zz,'-r+');
hold on
plot(y-zz,'-bo')
grid on
xlabel('Time [min]','FontSize',14)
ylabel('Water level [m]','FontSize',14);
legend ('original ','original signal + measuring noise','signal reconstructed from reduced spectrum', 'orig-reconstr','orig+noise-reconstr.');
title('Original signal and the reconstructed signal from reduced spectrum');