function Y = uTypeA(yk,alpha)
% (C) JLBK, 06/2018, revised 08/2018
% Two inputs
% 1 yk: vertical vector of n repeated measurements of the quantity Y
% 2 alpha: level of probability for the coverage interval
% Outputs vector Y
% Y(1): best estimate Ybar of the true value of Y from the measurements yk 
% Y(2): standard uncertainty of Ybar
% Y(3): low boundary Ylow of the coverage interval of Ybar
% Y(4): high boundary Yhigh of the coverage interval of Ybar

% calculation of Ybar
Y(1) = mean(yk);
% calculation of uYbar
Y(2) = std(yk)/sqrt(length(yk));
% calculation of Ylow and Yhigh
Y(3) = Y(1) - tinv((1+alpha)/2, length(yk)-1)*Y(2);
Y(4) = Y(1) + tinv((1+alpha)/2, length(yk)-1)*Y(2);