clear all
close all
load('IWA_hydro.mat');
% % built a model to fill time gaps used for IWA paragraph 9.4.4
itel=0;
best=100;
horizon=60;
venster=size(x1,1);
for p=1:1:5
    for q=1:1:2
        itel=itel+1;
        Mdl=arima(p,2,q);
        x11=x1(1:horizon);
        EstMdl=estimate(Mdl,x11);
        AIC(itel)=summarize(EstMdl).AIC;
        residual=infer(EstMdl,x11);
        ARMA=x11+residual;
        RMSEtr(itel)=sqrt(dot(residual,residual))/horizon;
        if AIC(itel)<best
            best=AIC(itel);
            RMSEbest=RMSEtr(itel);
            p_best=p;
            ibest=itel;
            q_best=q;
        end
    end
end
h=figure;
for i=1:1:2
    if i==2
        p_best=4;
        q_best=2;
    end
    Mdl=arima(p_best,2,q_best);
    EstMdl=estimate(Mdl,x11);
    residual=infer(EstMdl,x11);
    ARMA=x11+residual;
    [Y]= forecast(EstMdl,venster-horizon,x11);

    if i==1
       subplot(3,1,1)
    else
        subplot(3,1,2)
    end
    plot(x11,'-k','LineWidth',2);
    hold on
    plot([horizon+1:venster],Y,'-or');
    hold on
    plot(x1,'-.b');
    hold on
    plot(ARMA,'-bo');
    hold on
    res=Y-x1(horizon+1:venster);
    RMSEC=sqrt(dot(res,res))/(venster-horizon);
    hold on
    plot([horizon+1:venster],res,' *r');
    hold on

    plot(ARMA(1:horizon)-x1(1:horizon),' *k')
    grid on
    plot([0,venster],[0,0],'-k','LineWidth',2);
    %if i==1
        legend('Training data','Cured data','original data','ARMA model','residue training','Residue forcast');
        title(['Cured data using an ARMA model, RMSE_t_r_a_i_n_i_n_g = ',num2str(RMSEtr(ibest)),' [m], RMSE_c_u_r_e_d = ',num2str(RMSEC),' [m], p = ',num2str(p_best),' q = ',num2str(q_best)]);

    %end
end
    subplot(3,1,3)
    autocorr(residual);
    title('Autocorrelation function residuals');
    xlabel('Time lag [min]');
    ylabel('Autocorrelation');
    grid on
set(findall(gcf,'-property','FontSize'),'FontSize',14);
set(findall(gcf,'-property','Font'),'Font','Arial');
title('Autocorrelation function residuals');
%
% curing data gap in manhole 1 using data + model from manhole 2
%
%first find best ARMA model for the difference between manhole1 - manhole 2

h=figure
plot(x1);
hold on
plot(x2);
verschil=x1-x2;
h=figure
plot(verschil);
hold on
best=100;
itel=0;
for p=1:1:5
    for q=1:1:3
        itel=itel+1;
        Mdl=arima(p,1,q);
        EstMdl=estimate(Mdl,verschil);
        AIC(itel)=summarize(EstMdl).AIC;
        residual=infer(EstMdl,verschil);
        ARMA=verschil+residual;
        RMSE=sqrt(dot(residual,residual))/size(x1,1);
        if AIC(itel) < best
            best=AIC(itel)
            bestrm=RMSE;
            ibest=itel;
            q_best=q;
            p_best=p;
        end

    end
end
clear verschil residual
% now the same for the first 60 minutes
h=figure;
x11=x1(1:horizon);
x22=x2(1:horizon);
plot(x11);
hold on
plot(x22);
verschil=x11-x22;
h=figure;
plot(verschil);
hold on
best=100;
itel=0;
for pp=1:1:5
    for qq=1:1:3
        itel=itel+1;
        Mdl=arima(pp,1,qq);
        EstMdl=estimate(Mdl,verschil);
        AIC_p(itel)=summarize(EstMdl).AIC;
        residual=infer(EstMdl,verschil);
        ARMA=verschil+residual;
        RMSE=sqrt(dot(residual,residual))/size(x11,1);
        if AIC_p(itel) < best
            best=AIC_p(itel);
            best=RMSE;
            ibest=itel;
            qq_best=qq;
            pp_best=pp;
        end
        h=figure;
        plot(ARMA);
        hold on;
        x44=x22+ARMA;
        plot(x44);
        hold on
        plot(x11);
        hold on
        plot(x22);
        hold on
        plot(x11-ARMA,'-*k');
        hold on
        plot(verschil,'-ok');
        grid on
        legend('ARMA','x44','x11','x22','x11-ARMA','Verschil 1 en 2');
        title(['ARMA(',num2str(pp),',',num2str(qq),')',' RMSE = ',num2str(RMSE)]);
    end
end
h=figure
for i=1:1:2
% use best for forecasting
    if i==2
        pp_best=2;
        qq_best=3;
    end
    Mdl=arima(pp_best,1,qq_best);
    EstMdl=estimate(Mdl,verschil);
    residual=infer(EstMdl,verschil);
    ARMA=verschil+residual;
    RMSE=sqrt(dot(residual,residual))/size(x11,1);
    [Y]= forecast(EstMdl,venster-horizon,verschil);

    subplot(2,1,i);
    plot(x1);
    hold on
    plot(x2);
    hold on 
    plot(x1-x2)
    hold on
    plot(ARMA);
    hold on
    plot(x11-ARMA)
    hold on
    cc=x1(horizon+1:venster)-Y;
    tt=[horizon+1:venster];
    plot(tt,cc,'-*r')
    hold on
    plot(residual,'-+k');
    hold on
    plot(tt,cc-x2(horizon+1:venster),'-+r');
    title([' Reconstructing a signal (x_2) from another signal(x1) + ARMA(',num2str(pp_best),',',num2str(qq_best),') model']);
    legend('Original x_1','Original x_2','x_1-x_2','ARMA model','x2 reconstructed (fitted)','x_2 forecasted','Residual fitted','residual reconstructed');
    xlabel('Time [min]');
    ylabel('Water level [m]');
    grid on
    totres(1:horizon)=residual;
    totres(horizon+1:venster)=cc-x2(horizon+1:venster);
end

[path,file_name]=save_graph('Arial',18);




%function sets font at fonttype (e.g. 'Arial') at font_size (e.g.  18)
% and saves the figure as .png  and .fig file
function[path,file_name]=save_graph(fonttype,font_size)
set(gcf,'WindowState','Maximized');
set(findall(gcf,'-property','FontSize'),'FontSize',font_size)
set(findall(gcf,'-property','Font'),'Font',fonttype)
file_name=input('What is the filename for the graph?:','s');
%select irectory
path=uigetdir;
let = 0.25; bottom = .25; width = 16*2; height = 9*2;
set(gcf,'PaperPosition',[left bottom width height]);
set(gcf,'PaperUnits','normalized');
print(gcf,strcat(path,'/',file_name),'-deps','-r600'); %'-r0'
savefig(gcf,strcat(path,'/',file_name));f
end