% determination confidence and power for step an linear trend for a range
% of window sizes (counter: window)
% y is series to analyse
sm=0.005;% sm sigma measuring resuls
alpha1=0.05; % alpha1 is the significance of the test
% sy is sigma process
load('outliers_example.mat');
n=size(y,1);power.m
yorg=y;
clear y
i_window=0;
iitel=0;
for window=50:50:400
    i_window=i_window+1;
    step_max=0;
    lin_max=0;
    for i=1+window/2:50:n-window/2
        iitel=iitel+1;
        y=yorg(i-window/2:i+window/2);
        sy=std(y);

        % find the autocorrelation function for y
        rho_ix=autocorr(y(1:window+1),'NumLags',window);
        rho_ix=rho_ix.*sy^2;
        rho_ix(1)=sy^2+sm^2;
        rho_ix=rho_ix./(sy^2+sm^2);
        term1=0;
        for i=1:1:window
            term1=term1+2*(1-i/window)*rho_ix(i);
        end
        nequal=window/(1+term1);
        sy=std(y);
 %       sm=0.0005;
        clear rho_ix
        for ratio=1:1:8
            ration=1+(ratio-1)*0.5;
            rr(ratio)=ration;
            tr=ration*sy;
            phi_step(ratio,i_window)=ration*0.5*sqrt(nequal);
            phi_lin(ratio,i_window)=ration/sqrt(12)*(sqrt(nequal*(nequal+1)*nequal-1))/window;
        end        
        % now show the relation between alpha (sigificance) and beta (power)
        chi=norminv(1-alpha1/2);
        for i=1:1:8
            p_step_v(i,i_window)=(phi_step(i,i_window)-chi);
            p_lin_v(i,i_window)=(phi_lin(i,i_window)-chi);
            power_step(i,i_window)=normcdf(((phi_step(i,i_window)-chi)),0,1);

            power_lin(i,i_window)=normcdf((phi_lin(i,i_window))-chi,0,1);
        end
        if mean(power_step(:,i_window))>step_max
            step_power(:,i_window)=(power_step(:,i_window));
        end
        if mean(power_lin(:,i_window))>lin_max
            lin_power(:,i_window)=(power_lin(:,i_window));
        end
    end
    Legend{(2*i_window-1)}=strcat('Window = ',num2str(window),' min, Step trend');
    Legend{(2*i_window)}=strcat('Window = ',num2str(window),' min, Linear trend');
end
h=figure;
for i=1:1:i_window
    len=2;
    if i~=1 && i~= i_window
        len=1;
    end
    if i~=1 && i~=i_window
        plot(rr,step_power(:,i),'.-k','LineWidth',len);
        hold on
        plot(rr,lin_power(:,i),'.-r','LineWidth',len);
        hold on
    else
        if i==1
            plot(rr,step_power(:,i),'-k','LineWidth',len);
            hold on
            plot(rr,lin_power(:,i),'-r','LineWidth',len);
            hold on
        else
            plot(rr,step_power(:,i),'-k','LineWidth',len);
            hold on
            plot(rr,lin_power(:,i),'-r','LineWidth',len);
            hold on      
        end
    end
        
end
xlabel('T_r/\sigma_p');
ylabel('(1-\beta) (power)');
title(['Mesuring uncertainty = ',num2str(sm),' [m],  \alpha=',num2str(alpha1)]);
grid on
legend(Legend);