clear all
close all
load('outliers_example.mat');
yorg=y;
std_meet=0.05;
clear x;
for i=1:1:size(y,1)
    x(i)=i;
end
x=x';
% Generate a graph to show the performance of Cooks distance test depending
% on the threshold imposed
%load('your file holding two colums;x (time), y(measured value')
mdl = fitlm(x,y);
h=figure;
plotDiagnostics(mdl,'cookd');
hold on
%
%
% use 50 different threshold values and determin the number of outliers detected as 
% a function of threshold value
for i=1:1:50
    thresh(i)=0.5+(i-1)*0.25;
    indi=find((mdl.Diagnostics.CooksDistance)>thresh(i)*mean(mdl.Diagnostics.CooksDistance));
    num_of(i)=size(indi,1);
end
% plot results
h=figure;
plot(thresh,num_of,'-k');
grid on
xlabel('Threshold [# * mean value]');
ylabel('Number of outliers detected [-]');
title('Number of outliers detected by Cooks distance as a function of threshold')

clear indi;
max_val=3*mean(mdl.Diagnostics.CooksDistance);
indi=find((mdl.Diagnostics.CooksDistance)>max_val);
xlabel('Time [min]')
ylabel('Cooks distance [-]')
title(['Cooks distance as a function of time, threshold =',num2str(max_val),' being 3 times the mean value']);
for i=1:1:size(indi,1)
    plot(indi(i),y(indi(i)),'-k');
    hold on
        plot(indi(i),mdl.Diagnostics.CooksDistance(indi(i)),' ok');
    hold on
end
plot([0,1500],[max_val,max_val],'-r');
h=figure;
plot(x,y);
hold on
plot(indi(1:size(indi,1)),yorg(1:size(indi,1)),' or');
hold on
title('Outliers identified with Cooks distance, threshold: 3*mean');
xlabel('Time [min]');
ylabel('water level');
grid on



%Z-test on the whole set using 10 different Z_max values a threshold

for j=1:1:10
    Z_max=j*0.5;
    Ztop(j)=Z_max;
    s=std(yorg);
    gemid=mean(yorg);
    Z=(yorg-gemid)/s;
    h=figure;
    %plot(x,Z/max(Z));
    %hold on
    %plot(x,yorg/max(yorg));
    xlabel('time')
    ylabel('Z-value');
    grid on
    %identify all points with a value above threshold
    indiz =find(abs(Z)>Z_max);
    Num_of_out(j)=size(indiz,1);
    hold on
    plot(x,yorg,'-b');
    hold on
    plot(x(indiz),yorg(indiz),' r*');
    title(['outliers identified with the Z-test, threshold=',num2str(Z_max), '[m]']);
end
h=figure;
plot(Ztop,Num_of_out);
xlabel('Z_m_a_x');
ylabel('Number  of outliers detected');
title('Number of detected outliers using the Z-test as a function of  Z_m_a_x');
grid on



%Z-test on a moving window
% threshold values varies in 10 steps of 0.1 starting a 2.5 (counter jjk)§
% the window size varies between 50 and 70 in steps of 20 (counter w)

for jjk=1:1:10
  iitel=0;
  for w=50:20:70
    iitel=iitel+1;
    itelz=0;
    Legend{iitel}=strcat('Window size = ',num2str(w));
    Z_max=2.5+(jjk-1)*0.1;
    Z_to(iitel,jjk)=Z_max;
    for i=w/2:1:size(yorg,1)-w/2-1
        gemid(i)=mean(yorg(i-w/2+1:i+w/2+1));
        ss(i)=std(yorg(i-w/2+1:i+w/2+1));
        Z=(yorg(i-w/2+1:i+w/2-1)-gemid(i))/ss(i);
        indiz=find(abs(Z)>Z_max);
        if size(indiz,2)>0
            for jj=1:1:size(indiz)
                itelz=itelz+1;
                inout(itelz)=indiz(jj)+i-w/2;
                Z_res(itelz)=Z(jj);
            end
        end
        clear Z
    end
    index1=unique(inout);
    h=figure;
    plot(x,yorg,'-b');
    hold on
    plot(x(index1),yorg(index1),' r*');
    xlabel('Time [min]');
    ylabel('Water level [m]');
    title({['outliers identified with the Z-test, threshold=',num2str(Z_max), '[m]'],...
        ['window=',num2str(w),' Z_m_a_x = ',num2str(Z_max),' Nr. outlier= ',...
        num2str(size(index1,2))]});
    grid on
    legend('Data','Identified outlier');
    num_z_window(jjk,iitel,1)=size(index1,2);
    num_z_window(jjk,iitel,2)=Z_max;
    num_z_window(jjk,iitel,3)=w;
    if exist('inout')
        clear inout
    end
    if exist('index1')
        clear index1
    end
  end
end
h=figure;
for j=1:1:iitel
    plot(num_z_window(:,j,2),num_z_window(:,j,1))
    hold on
end
xlabel('Z_m_a_x');
ylabel('Nuber of outliers [-]');
grid on
legend(Legend);
title('Number of detected outliers Z test as a function of Z_m_a_x and window size');

% Grubbs test

ybewaar=yorg;
num_of_min=zeros(5,5);
num_of_max=zeros(5,5);
for jjk=1:1:5
  iitel=0;
  %alpha for crtical value in t-students distr for the Grubbs criterium
  alha1(jjk)=0.005+0.01*(jjk-1);
  for w=60:10:100
    iitel=iitel+1; window(iitel)=w;
    itelg=0;
    itelgmin=0;
    itelgmax=0;
    Tv=tinv(1-alha1(jjk)/(2*w),w-2); Tvv=tinv(1-alha1(jjk)/w,w-2);
    ww=w;
    if (w-2*Tv^2)<0
         G_test=0;
         disp 'invalid combination of alpha and degrees of freedom double sided'
         validg=0;
    else
         G_test=(w-1)/sqrt(w)*sqrt(Tv^2/(w-2*Tv^2));ww=w/2;validg=1;
    end
    if (ww-2*Tvv^2)<0
         G_test_min_max=0;
         disp 'invalid combination of alpha and degrees of freedom one-sided'
         validgmin=0; num_of_max(iitel,jjk)=0; num_of_min(iitel,jjk)=0;
    else
         G_test_min_max=(ww-1)/sqrt(ww)*sqrt(Tvv^2/(ww-2*Tvv^2)); validgmin=1;
    end
    if validg &&validgmin
        for i=w/2:1:size(yorg,1)-w/2-1
            gemid(i)=mean(yorg(i-w/2+1:i+w/2+1));
            ss(i)=std(yorg(i-w/2+1:i+w/2+1));H=(abs((yorg(i-w/2+1:i+w/2+1)-gemid(i))/ss(i))); G=max(H); gg(i)=G;
            Gmin=((gemid(i)-min(yorg(i-w/2+1:i+w/2+1)))/ss(i));[~,idxmin]=min(yorg(i-w/2+1:i+w/2+1)/ss(i));
            [~,idxmax]=max(yorg(i-w/2+1:i+w/2+1)/ss(i));
            Gmax=((-gemid(i)+max(yorg(i-w/2+1:i+w/2+1)))/ss(i));
            if G>G_test
                    itelg=itelg+1;
                    [~,idx]=max(H);inoutg(itelg)=idx+1-w/2;G_res(itelg)=G;indexG=unique(inoutg);
            end
            if max(Gmin)>G_test_min_max
                     itelgmin=itelgmin+1;
                     inoutgmin(itelgmin)=idxmin+i-w/2;
                     yorg(idx+i-w/2)=0.5*(yorg(idxmin+i-w/2-1)+yorg(idxmin+i-w/2+1));
                     G_res_min(itelgmin)=max(Gmin);indexGmin=unique(inoutgmin);num_of_min(iitel,jjk)=size(indexGmin,2);
            end
            if max(Gmax)>G_test_min_max
                     itelgmax=itelgmax+1;inoutgmax(itelgmax)=idxmax+i-w/2;
                     yorg(idx+i-w/2)=0.5*(yorg(idxmax+i-w/2-1)+yorg(idxmax+i-w/2+1));
                     G_res_max(itelgmax)=max(Gmax);
                     indexGmax=unique(inoutgmax);num_of_max(iitel,jjk)=size(indexGmax,2);
            end
        end
        yorg=ybewaar;
        if exist('indexGmax') && exist('indexGmin') && exist('indexG')
                h=figure;plot(x,yorg,'-b');hold on
                plot(x(indexGmax),yorg(indexGmax),' ro');hold on
                plot(x(indexGmin),yorg(indexGmin),' go');hold on
                if validgmin==1
                    title({['outliers identified with the Grubbstest  window=',num2str(w),' \alpha = ',...
                        num2str(alha1(jjk))],[' Number of minima =',num2str(num_of_min(iitel,jjk)),...
                        ' Number of maxima = ',num2str(num_of_max(iitel,jjk))]});
                else
                    title(['outliers identified with the Grubbstest  window=',num2str(w),' \alpha = '...
                        ,num2str(alha1(jjk)), 'NO VALID COMBINATION']);
                end
                grid on
         end
        end
      end
    end





if exist('num_of_max') && exist('num_of_min')
    h=figure;
    for jjk=1:1:size(num_of_max,1)

        plot(alha1,num_of_max(:,jjk)+num_of_min(:,jjk),'-ok');
        hold on
    %     plot(alha1,num_of_min(:,jjk));
    %     hold on
    %     plot(alha1,num_of_max(:,jjk,:)+num_of_min(:,jjk),'-k','LineWidth',2);
    %     grid on
        xlabel('\alpha [-]');
        ylabel('# extremese')
    end
    title('Number of detected outliers for different window sizes and \alpha values for the Grubbs test')
    legend(['Window =',num2str(window(1))],['Window =',num2str(window(2))],['Window =',num2str(window(3))],['Window =',num2str(window(4))],['Window =',num2str(window(5))]);
    grid on
    
        h=figure;
    for jjk=1:1:size(num_of_max,1)

        plot(alha1,num_of_min(:,jjk));
        hold on
    %     plot(alha1,num_of_min(:,jjk));
    %     hold on
    %     plot(alha1,num_of_max(:,jjk,:)+num_of_min(:,jjk),'-k','LineWidth',2);
    %     grid on
        xlabel('\alpha [-]');
        ylabel('# Minina')
    end
    legend(['Window =',num2str(window(1))],['Window =',num2str(window(2))],['Window =',num2str(window(3))],['Window =',num2str(window(4))],['Window =',num2str(window(5))]);
    grid on
        h=figure;
    for jjk=1:1:size(num_of_max,1)

        plot(alha1,num_of_max(:,jjk),'-ok');
        hold on
    %     plot(alha1,num_of_min(:,jjk));
    %     hold on
    %     plot(alha1,num_of_max(:,jjk,:)+num_of_min(:,jjk),'-k','LineWidth',2);
    %     grid on
        xlabel('\alpha [-]');
        ylabel('# Maxima')
    end
    legend(['Window =',num2str(window(1))],['Window =',num2str(window(2))],['Window =',num2str(window(3))],['Window =',num2str(window(4))],['Window =',num2str(window(5))]);
    grid on
end
set(findall(gcf,'-property','FontSize'),'FontSize',14);

set(findall(gcf,'-property','Font'),'Font','Arial');
        
    
