
close all
clear all
load('outliers_example.mat');
alha=0.05;
chi=norminv(1-alha/2);
chi_laag=norminv(alha/2);
n=size(y,1);
for i=1:1:n
    x(i)=i;
end
% use matlab function findchangepts
h=figure;
num_win=20;
ipxo=findchangepts(yo,'MaxNumChanges',num_win);
h=figure;
ipx=findchangepts(y,'MaxNumChanges',num_win);
[ YI ] = lsq_lut_piecewise( x', y, ipxo );
plot(x,yo,'-k',ipxo,YI,'+-r')
legend('experimental data (x,y(x))','LUT points (ipx,YI)');
title('Piecewise 1-D look-up table least square estimation');
% linear trend analysis using Spearmans rho
% first linear fit;
for i=1:1:num_win-1
    start(i)=ipxo(i);
    eind(i)=ipxo(i+1);
    % test for siezes
    L=eind(i)-start(i);
    test=round(L/2)-L/2;
    if test ==0.5
        eind(i)=eind(i)+1;
    end
    midden(i)=round(0.5*(start(i)+eind(i)));
    X(i,:)=x(start(i):eind(i));
    Y(i,:)=yo(start(i):eind(i));
    XS=X(i,:)';
    YS=Y(i,:)';
    mdl=fitlm(X(i,:),Y(i,:),'linear');
    a(i)=mdl.Coefficients{1,1};
    b(i)=mdl.Coefficients{2,1};
    pa(i)=mdl.Coefficients{1,4};
    pb(i)=mdl.Coefficients{2,4};
    %make a partition over Y and Z
    mid=round(size(Y,2)/2);
    YY=Y(i,1:mid);
    ZZ=Y(i,mid:end);
    % Mann-Whitney test
    [Z1(i),Z2(i),Tr_ration(i)]=mannwhitney(YY, ZZ);
    p1(i)=normcdf(Z1(i));
    p2(i)=normcdf(Z2(i));
    power1(i)=normcdf(Z1(i)-chi);
    power2(i)=normcdf(Z2(i)-chi_laag);
    %% spearmans rho test for linear trends
     [rho(i),p_value(i)] = corr(XS,YS,'Type','Spearman');
     clear X Y YY ZZ XS YS
end


h=figure;
subplot(2,1,1)
xlabel('Time')
ylabel('Water level')
plot(x,yo,'-k',ipxo,YI,'o-r')
legend('Original data','Piece wise linear');
grid on
xlabel('Time');
ylabel('Water level');
title('Piece wise linear representation');
%show mann -whitney test
subplot(2,1,2)
plot(midden,Z1,' bo');
hold on
plot(midden,Z2,' ro');
grid on
hold on
xlabel('Time');
ylabel('Z1 and Z2 values mann withney per window');
title('Z values for the Mann-Whitney test');
legend('Z1','Z2');
plot([0,1501],[chi,chi],':k');
hold on
plot([0,1501],[chi_laag,chi_laag],':k');
hold on
for i=1:1:num_win-1
    plot([start(i),eind(i)],[Z1(i),Z1(i)],'-bo');
    hold on
    plot([start(i),eind(i)],[Z2(i),Z2(i)],'-.ro');
    hold on
end
hold on
plot(midden,power1,' -gx');
hold on
plot(midden,power2,' -bx');
legend('p value for Z1','p value for Z2','Max Z value','Min Z value','Power 1','Power 2');
grid on
title(['p values for Mann-Whitney test for \alpha = ',num2str(alha)]);


h=figure;
subplot(3,1,1)

xlabel('Time')
ylabel('Water level')
plot(x,yo,'-k',ipxo,YI,'o-r')
legend('Original data','Piece wise linear');
grid on
xlabel('Time [min]');
ylabel('Water level');
title('Piece wise linear representation');
% spearmans test
subplot(3,1,2)
for i=1:1:num_win-1
    plot([start(i),eind(i)],[rho(i),rho(i)],'-bo');
    hold on
end
grid on
xlabel('Time [min]');
ylabel('Spearmans \rho [-]');
title(['\rho for Spearmans \rho test, \alpha = ',num2str(alha)]);
hold on
subplot(3,1,3);
for i=1:1:num_win-1
    plot([start(i),eind(i)],[p_value(i),p_value(i)],'-ko');
    hold on
end
plot([0,1501],[alha/2,alha/2],':k');
hold on
plot([0,1501],[1-alha/2,1-alha/2],':k');
hold on
xlabel('Time [min]');
ylabel('p_v_a_l_u_e [-]');
title(['p_v_a_l_u_e [-] Spearmans \rho test, \alpha = ',num2str(alha)]);
grid on
hold on



% % Test for lsq_lut_piecewise function
% % generate noisy x and y data
% x = [-10:0.1:10]';
% x = x+2*(rand(size(x))-0.5);
% x = max(min(x,10),-10);
% y = x+x.^2+10*sin(x)+5*(rand(size(x))-0.5);
% % vector of 1-D look-up table "x" points
% XI = linspace(min(x),max(x),10);
% % obtain vector of 1-D look-up table "y" points
% YI = lsq_lut_piecewise( x, y, XI );
% % plot fit
% plot(x,y,'.',XI,YI,'+-')
% legend('experimental data (x,y(x))','LUT points (XI,YI)')
% title('Piecewise 1-D look-up table least square estimation')


function [ YI ] = lsq_lut_piecewise( x, y, XI )
% LSQ_LUT_PIECEWISE Piecewise linear interpolation for 1-D interpolation (table lookup)
%   YI = lsq_lut_piecewise( x, y, XI ) obtain optimal (least-square sense)
%   vector to be used with linear interpolation routine.
%   The target is finding Y given X the minimization of function 
%           f = |y-interp1(XI,YI,x)|^2
%   
%   INPUT
%       x measured data vector
%       y measured data vector
%       XI break points of 1-D table
%
%   OUTPUT
%       YI interpolation points of 1-D table
%           y = interp1(XI,YI,x)
%
if size(x,2) ~= 1
    error('Vector x must have dimension n x 1.');   
elseif size(y,2) ~= 1
    error('Vector y must have dimension n x 1.');    
elseif size(x,1) ~= size(x,1)
    error('Vector x and y must have dimension n x 1.'); 
end
% matrix defined by x measurements
A = sparse([]); 
% vector for y measurements
Y = []; 
for j=2:length(XI)  
    % get index of points in bin [XI(j-1) XI(j)]
    ix = x>=XI(j-1) & x<XI(j); 
    % check if we have data points in bin
    if ~any(ix)
        warning(sprintf('Bin [%f %f] has no data points, check estimation. Please re-define X vector accordingly.',XI(j-1),XI(j)));
    end
    % get x and y data subset
    x_ = x(ix);
    y_ = y(ix);
    % create temporary matrix to be added to A
    tmp = [(( -x_+XI(j-1) ) / ( XI(j)-XI(j-1) ) + 1) (( x_-XI(j-1) ) / ( XI(j)-XI(j-1) ))];
    % build matrix of measurement with constraints
    [m1,n1]=size(A);
    [m2,n2]=size(tmp);
    A = [[A zeros(m1,n2-1)];[zeros(m2,n1-1) tmp]];
    % concatenate y measurements of bin
    Y = [Y; y_];
end
% obtain least-squares Y estimation
YI=A\Y;
end



function [Z1,Z2, Tr_ratio]=mannwhitney(set1, set2)
% function returns Z1 and Z2 value for the mann-whitney test
setorg=[set1,set2];
sigmap=std(setorg);
Tr_ratio=abs(mean(set1)-mean(set2))/sigmap;
set1=[set1 ones(size(set1))];
set2=[set2 zeros(size(set2))];
set= [set1;set2];
sortset=sortrows(set) ; 
n=size(set,1);
n1=sum(sortset(:,2));
n2=n-n1;
% tied ranks
sortset=[sortset (1:n)'];
d=diff(sortset (:,1));
i=1; 
while i<=n-1
    switch d(i)
    case 0
        k=1 ; 
        while (i+k) <=n-1 && d(i+k)==0
            k=k+1;
        end
        gem=(sortset(i,3)+sortset(i+k,3) )/2 ; 
        for j=i:i+k
            sortset(j,3)=gem;
        end
    i=i+k;
        otherwise
            i=i+1;
    end
end
T1=0;
T2=0;
for i=1:n
    switch (sortset(i,2) )
        case 1 
            T1=T1+sortset(i,3); 
        otherwise
            T2=T2+sortset(i,3);
    end
end
Mu1=n1*(n+1)/2; 
Mu2=n2*(n+1)/2;
SigmaT=sqrt(n1*n2*(n+1)/12 );
if T1-Mu1 <0
    Z1=(T1-Mu1+0.5)/SigmaT ;
elseif T1 - Mu1>0
        Z1=(T1-Mu1-0.5)/SigmaT;
else
        Z1=(T1-Mu1)/SigmaT;
end 
if T2-Mu2 <0
    Z2=(T2-Mu2+0.5)/SigmaT;
elseif T2-Mu2>0
    Z2=(T2-Mu2-0.5)/SigmaT;
else % als T2=Mu2
    Z2=(T2-Mu2)/SigmaT;
end
Z2=real(Z2);
Z1=real(Z1);
end
        
