%close all
clear all
load('outliers_example.mat');
alpha1=0.05;
chi=norminv(1-alpha1/2);

n=size(yo,1);
i_window=0;
for window=20:10:400
    i_window=i_window+1
    ww(i_window)=window;
    for i=window/2+1:1:n-window/2
        X=yo(i-window/2:i+window/2);
        %make a partition over Y and Z
        Y=X(1:window/2);
        Z=X(window/2+2:size(X,1));
        [Z1(i_window,i),Z2(i_window,i)]=mannwhitney(Y, Z);
        p1(i_window,i)=normcdf(Z1(i_window,i));
        p2(i_window,i)=normcdf(Z2(i_window,i));
        % calculate the power of the test
        power1(i_window,i)=normpdf(Z1(i_window,i)-chi);
        power2(i_window,i)=normpdf(Z2(i_window,i)-chi);
        % determing maimum relative trend:
        tr(i_window,i)=abs(mean(Y)-mean(Z))/std(X);
    end
end
xx=[0,n];
ylow=[alpha1/2,alpha1/2];
yhigh=[1-alpha1/2,1-alpha1/2];
for j=1:1:i_window-1
    plot(yo,'-k');
    hold on
    h=figure;
    plot(xx,ylow,'.-k');
    hold on
    plot(xx,yhigh,'--k');
    hold on

    index1=(p1(i_window,:)>1-alpha1/2);
    idx1=find(index1==1);
    index2=(p1(i_window,:)<alpha1/2);
    idx2=find(index2==1);
%     plot(idx1,p1(i_window,idx1),' ro');
%     hold on
%     plot(idx2,p1(i_window,idx2),' go');
    grid on
    hold on
    clear index1 index 2 idx1 idx2
    index11=(p2(i_window,:)>1-alpha1/2);
    idx11=find(index11==1);
    index21=(p2(i_window,:)<alpha1/2);
    idx21=find(index21==1);
      plot(idx11,p2(i_window,idx11),'-r');
      hold on
      plot(idx21,p2(i_window,idx21),'-g');
     grid on
    hold on
    
    plot(p1(j,:),'-k');
    hold on
    plot(idx11,p2(j,idx11),'-r','LineWidth',2);
    hold on
    plot(p2(j,:),'-r');
    
    clear index11 index21 idx11 idx21
    xlabel('Time [min]');
    ylabel('Water level [m]');
    title(['Steptrends detected, window = ',num2str(ww(j)),' [min], \alpha = ',num2str(alpha1)]);
    hold on
    legend('Original data','1-\alpha/2','\alpha/2','p_1','p_2');
end
    
function [Z1,Z2]=mannwhitney(set1, set2)
% function returns Z1 and Z2 value for the mann-whitney test for set1 and
% set2
set1=[set1 ones(size(set1))];
set2=[set2 zeros(size(set2))];
set= [set1;set2];
sortset=sortrows(set) ; 
n=size(set,1);
n1=sum(sortset(:,2));
n2=n-n1;
% tied ranks
sortset=[sortset (1:n)'];
d=diff(sortset (:,1));
i=1; 
while i<=n-1
    switch d(i)
    case 0
        k=1 ; 
        while (i+k) <=n-1 && d(i+k)==0
            k=k+1;
        end
        gem=(sortset(i,3)+sortset(i+k,3) )/2 ; 
        for j=i:i+k
            sortset(j,3)=gem;
        end
    i=i+k;
        otherwise
            i=i+1;
    end
end
T1=0;
T2=0;
for i=1:n
    switch (sortset(i,2) )
        case 1 
            T1=T1+sortset(i,3); 
        otherwise
            T2=T2+sortset(i,3);
    end
end
Mu1=n1*(n+1)/2; 
Mu2=n2*(n+1)/2;
SigmaT=sqrt(n1*n2*(n+1)/12 );
if T1-Mu1 <0
    Z1=(T1-Mu1+0.5)/SigmaT ;
elseif T1 - Mu1>0
        Z1=(T1-Mu1-0.5)/SigmaT;
else
        Z1=(T1-Mu1)/SigmaT;
end 
if T2-Mu2 <0
    Z2=(T2-Mu2+0.5)/SigmaT;
elseif T2-Mu2>0
    Z2=(T2-Mu2-0.5)/SigmaT;
else % als T2=Mu2
    Z2=(T2-Mu2)/SigmaT;
end
Z2=real(Z2);
Z1=real(Z1);
end
 
